Imports System
Imports System.Collections.Generic
Imports System.Text

Module ConvertDataType
    Sub Main()

        Dim data() As UShort
        'Convert ushort array to Long, data[0]=>Low Word, data[1]=>High Word
        data = New UShort(1) {4, 65530}
        Dim longValue As Long
        longValue = CInt(((CInt(data(1)) << 16) Or CInt(data(0))))
        Try
            Console.WriteLine(longValue.ToString()) '-393212
            Console.ReadLine()
        Catch ex As Exception
        End Try

        'Convert ushort array to UnsignedLong, data[0]=>Low Word, data[1]=>High Word
        data = New UShort(1) {25520, 13587}
        longValue = CUInt(((CUInt(data(1)) << 16) Or CUInt(data(0))))
        Try
            Console.WriteLine(longValue.ToString()) '890463152
            Console.ReadLine()
        Catch ex As Exception
        End Try

        'Convert ushort array to Hex 
        data = New UShort(0) {65535}
        Console.WriteLine(data(0).ToString("X4"))  'FFFF
        Console.ReadLine()

        'Convert ushort array to Float 
        data = New UShort(1) {59769, 17142}
        Dim floatData() As Single = {0}
        Buffer.BlockCopy(data, 0, floatData, 0, data.Length * 2)
        For index As Integer = 0 To floatData.Length - 1
            Console.WriteLine(floatData(index / 2).ToString("0.0000")) '123.4560
            Console.ReadLine()
        Next index

        'Convert ushort value to Int16                         
        Dim ushortValue As UShort = 65516
        Dim int16Value = UnsignedToInteger(ushortValue)
        Console.WriteLine(int16Value.ToString()) '-20
        Console.ReadLine()

        '    //------------------------------------------------------------------------------------------

        Dim uintData() As UShort
        'Convert long value to Ushort array  
        uintData = New UShort(1) {1, 0}
        Dim longData() As Long = New Long(0) {-65532}
        Buffer.BlockCopy(longData, 0, uintData, 0, 4)
        For index As Integer = 0 To 1
            'uintData[0] = 4 ;uintData[1] = 65535
            Console.WriteLine(String.Format("uintData[{0}] = {1}", index, uintData(index)))
        Next index
        Console.ReadLine()

        '//Convert unsignedLong value to Ushort array          
        Dim ulongData() As ULong = New ULong(0) {890463152}
        Buffer.BlockCopy(ulongData, 0, uintData, 0, 4)
        For index As Integer = 0 To 1
            'uintData[0] = 25520;uintData[1] = 13587
            Console.WriteLine(String.Format("uintData[{0}] = {1}", index, uintData(index)))
        Next index
        Console.ReadLine()

        'Convert hex value to Ushort
        Dim hexValue As String = "FFEC"
        Console.WriteLine(Convert.ToInt32(hexValue, 16))  '65516       
        Console.ReadLine()


        'Convert float value to Ushort 
        floatData = New Single(0) {223.456F}
        Buffer.BlockCopy(floatData, 0, uintData, 0, 4)
        For index As Integer = 0 To 1
            'uintData[0] = 29884 ;uintData[1] = 17247
            Console.WriteLine(String.Format("uintData[{0}] = {1}", index, uintData(index)))
        Next index
        Console.ReadLine()

        ''Convert int16 value to Ushort           
        Dim intValue() As Short = New Short(0) {-35}
        uintData = New UShort(0) {0}
        Buffer.BlockCopy(intValue, 0, uintData, 0, 2)
        For index As Integer = 0 To 0
            Console.WriteLine(String.Format("uintData[{0}] = {1}", index, uintData(index))) '65501
        Next index
        Console.ReadLine()


    End Sub

    'Function for Unsigned To Integer & Integer To Unsigned
    Private Const OFFSET_2 = 65536
    Private Const MAXINT_2 = 32767
    Function UnsignedToInteger(ByVal Value As Long) As Integer
        If Value < 0 Or Value >= OFFSET_2 Then Error 6 ' Overflow
        If Value <= MAXINT_2 Then
            UnsignedToInteger = Value
        Else
            UnsignedToInteger = Value - OFFSET_2
        End If
    End Function

    Function IntegerToUnsigned(ByVal Value As Integer) As Long
        If Value < 0 Then
            IntegerToUnsigned = Value + OFFSET_2
        Else
            IntegerToUnsigned = Value
        End If
    End Function

End Module
